void calcnormals(object3D *objp2,int cpolygon,float *nx,float *ny,float *nz)
{  int ux,vx,uy,vy,uz,vz;
   float lengthpn;
   float pomnormx,pomnormy,pomnormz;
   int i;
   
   i=cpolygon;
   ux=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].x-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].x;
   vx=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].x-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].x;
   uy=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].y-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].y;
   vy=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].y-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].y;
   uz=objp2->orgvertexes[objp2->polys[i].whichvertexes[2]].z-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].z;
   vz=objp2->orgvertexes[objp2->polys[i].whichvertexes[3]].z-objp2->orgvertexes[objp2->polys[i].whichvertexes[1]].z;
   *nx=(uy*vz-uz*vy);     /*normala nenormalizovana*/
   *ny=(uz*vx-ux*vz);
   *nz=(ux*vy-uy*vx);
}


/*inicializuje normaly a pseudonormaly*/
void Ginitnorm(object3D *objp,Point3D *light_p,
               Point3Df *lightn_p) 
{
   float lightl;
   int ux,vx,uy,vy,uz,vz;
   float pomnormx,pomnormy,pomnormz;
   float nnormx,nnormy,nnormz;  
   float lengthpn;  
   int i,i1,i2;  

   float cx,cy,cz; //pro pseudonormaly
   int cn;  
      
   cx=cy=cz=0.0;
   cn=0;


  /*velikost normaly a normalizace svetla*/

   lightl=sqrt((light_p->x*light_p->x)+(light_p->y*light_p->y)+(light_p->z*light_p->z));
   lightn_p->x=light_p->x/lightl;
   lightn_p->y=light_p->y/lightl;
   lightn_p->z=light_p->z/lightl;
   
   for(i=1;i<(objp->Npolys+1);i++) 
   {
    calcnormals(objp,i,&pomnormx,&pomnormy,&pomnormz);
 /* stary zpusob  neplati
  ux=objp->orgvertexes[objp->polys[i].whichvertexes[2]].x-objp->orgvertexes[objp->polys[i].whichvertexes[1]].x;
  vx=objp->orgvertexes[objp->polys[i].whichvertexes[3]].x-objp->orgvertexes[objp->polys[i].whichvertexes[1]].x;
  uy=objp->orgvertexes[objp->polys[i].whichvertexes[2]].y-objp->orgvertexes[objp->polys[i].whichvertexes[1]].y;
  vy=objp->orgvertexes[objp->polys[i].whichvertexes[3]].y-objp->orgvertexes[objp->polys[i].whichvertexes[1]].y;
  uz=objp->orgvertexes[objp->polys[i].whichvertexes[2]].z-objp->orgvertexes[objp->polys[i].whichvertexes[1]].z;
  vz=objp->orgvertexes[objp->polys[i].whichvertexes[3]].z-objp->orgvertexes[objp->polys[i].whichvertexes[1]].z;
    pomnormx=(uy*vz-uz*vy);     
    pomnormy=(uz*vx-ux*vz);
    pomnormz=(ux*vy-uy*vx);
  */  
   /*delka nenormalizovane normaly*/

   lengthpn=(sqrt(pomnormx*pomnormx+pomnormy*pomnormy+pomnormz*pomnormz));
   if (lengthpn==0.0) lengthpn=1.0;
    /*konecna uprava normaly polygonu*/
    nnormx=pomnormx/lengthpn;
    nnormy=pomnormy/lengthpn;
    nnormz=pomnormz/lengthpn;
    
    objp->polys[i].normal.x=nnormx;
    objp->polys[i].normal.y=nnormy;
    objp->polys[i].normal.z=nnormz;
   }  
   
    //vypocet pseudonormal pro kazdy vertex 
    for(i1=1;i1<=objp->Nvertex;i1++)
    {cx=0.0,cy=0.0,cz=0.0,cn=0;
     for(i2=1;i2<=objp->Npolys;i2++)
     {
      if ((objp->polys[i2].whichvertexes[1]==i1) ||
          (objp->polys[i2].whichvertexes[2]==i1) ||
          (objp->polys[i2].whichvertexes[3]==i1)) 
       {
        calcnormals(objp,i2,&pomnormx,&pomnormy,&pomnormz);
  /*    cx+=objp->polys[i2].normal.x;
        cy+=objp->polys[i2].normal.y;
        cz+=objp->polys[i2].normal.z;
     */
	cx+=pomnormx;
	cy+=pomnormy;
	cz+=pomnormz;
	cn++;
       }
    }
    if (cn) 
    { 
     cx/=cn;
     cy/=cn;
     cz/=cn;
     lengthpn=sqrt(cx*cx+cy*cy+cz*cz);
     if (lengthpn==0.0) lengthpn=1;
     //pseudonormala v intervalu 0 1
     objp->vertnorm[i1].x=cx/lengthpn;
     objp->vertnorm[i1].y=cy/lengthpn;
     objp->vertnorm[i1].z=cz/lengthpn;
     //pseudonormala s upravou na barvu}
     objp->pseudonorm[i1].x=(cx/(lengthpn*lightl)*Maxcol);
     objp->pseudonorm[i1].y=(cy/(lengthpn*lightl)*Maxcol);
     objp->pseudonorm[i1].z=(cz/(lengthpn*lightl)*Maxcol);
     }
    else printf("chyba ve vypoctu pseudonormal\n");
   } 
}


